# Before `make install' is performed this script should be runnable
# with `make test'. After `make install' it should work as `perl
# SAXParser.t'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..4\n"; }
END {print "not ok 1\n" unless $loaded;}
use Carp;
use XML::Xerces;
use Config;

use lib 't';
use TestUtils qw(result);
use vars qw($i $loaded);
use strict;

$loaded = 1;
$i = 1;
result($loaded);

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

my $document = q[<?xml version="1.0" encoding="utf-8" standalone="yes"?>
<contributors>
  <person Role="manager">
    <name>Mike Pogue</name>
    <email>mpogue@us.ibm.com</email>
  </person>
  <person Role="developer">
    <name>Tom Watson</name>
    <email>rtwatson@us.ibm.com</email>
  </person>
  <person Role="tech writer">
    <name>Susan Hardenbrook</name>
    <email>susanhar@us.ibm.com</email>
  </person>
</contributors>];

my $SAX = new XML::Xerces::SAXParser;
my $element_count = 0;
my $ws_count = 0;
my $char_count = 0;
my $DOCUMENT_HANDLER = XML::Xerces::perlDocumentHandler->new();
$DOCUMENT_HANDLER->setStartElementFunction(sub{$element_count++;});
$DOCUMENT_HANDLER->setIgnorableWhitespaceFunction(sub{my ($str,$len) = @_;
						      $ws_count += $len;});
$DOCUMENT_HANDLER->setCharactersFunction(sub{my ($str,$len) = @_;
					     $char_count += $len;});
$SAX->setDocumentHandler($DOCUMENT_HANDLER);

$SAX->parse(XML::Xerces::MemBufInputSource->new($document, 'foo'));
result($element_count == 10);
result($ws_count == 0);
result($char_count == 141);
