package TestUtils;
use XML::Xerces;
use strict;
use vars qw($VERSION
	    @ISA
	    @EXPORT
	    @EXPORT_OK
	    $DOM
	    $PERSONAL
	    $PERSONAL_FILE_NAME
	   );
use Carp;
use Cwd;
require Exporter;

@ISA = qw(Exporter);

@EXPORT_OK = qw(result
		$DOM
		$SAX
		$PERSONAL_FILE_NAME
		$PERSONAL);

BEGIN {
  # turn off annoying warnings
  $SIG{__WARN__} = 'IGNORE';

  $DOM = new XML::Xerces::DOMParser;
  $DOM->setToCreateXMLDeclTypeNode(1);

  my $ERROR_HANDLER = XML::Xerces::perlErrorHandler->new();
  $ERROR_HANDLER->setWarningFunction(\&XML::Xerces::warning);
  $ERROR_HANDLER->setErrorFunction(\&XML::Xerces::error);
  $ERROR_HANDLER->setFatalErrorFunction(\&XML::Xerces::fatal_error);
  $DOM->setErrorHandler($ERROR_HANDLER);

  my $cwd = cwd();
  $cwd =~ s|/t/?$||;
  $PERSONAL_FILE_NAME = 'personal.xml';
  $PERSONAL_FILE_NAME = "$cwd/$PERSONAL_FILE_NAME";
  open(PERSONAL, $PERSONAL_FILE_NAME)
    or die "Couldn't open $PERSONAL_FILE_NAME for reading";
  $/ = undef;
  $PERSONAL = <PERSONAL>;
  close PERSONAL;
}

sub result {
  my ($cond) = @_;
  print STDOUT "not " unless $cond;
  print STDOUT "ok ", $main::i++, "\n";
}
