# Before `make install' is performed this script should be runnable
# with `make test'. After `make install' it should work as `perl
# perlErrorHandler.t'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..3\n"; }
END {print "not ok 1\n" unless $loaded;}
use Carp;
use XML::Xerces;

use lib 't';
use TestUtils qw(result $DOM $PERSONAL);
use subs qw(warning error fatal_error);
use vars qw($error $loaded $i);

$loaded = 1;
$i = 1;
result($loaded);

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

my $document = <<\END;
<?xml version="1.0" encoding="iso-8859-1" standalone="no"?>

<!DOCTYPE personnel SYSTEM "personal.dtd">
<!-- @version: -->
<personnel>

  <person id="Big.Boss">
    <name><family>Boss</family> <given>Big</given></name>
    <email>chief@foo.com</email>
    <link subordinates="one.worker two.worker three.worker four.worker five.worker"/>
  </person>

  <person id="one.worker">
    <name><family>Worker</family> <given>One</given></name>
    <email>one@foo.com</email>
    <link manager="Big.Boss"/>
  </person>

  <foo id="two.worker">
    <name><family>Worker</family> <given>Two</given></name>
    <email>two@foo.com</email>
    <link manager="Big.Boss"/>
  </person>

  <person id="three.worker">
    <name><family>Worker</family> <given>Three</given></name>
    <email>three@foo.com</email>
    <link manager="Big.Boss"/>
  </person>

  <person id="four.worker">
    <name><family>Worker</family> <given>Four</given></name>
    <email>four@foo.com</email>
    <link manager="Big.Boss"/>
  </person>

  <person id="five.worker">
    <name><family>Worker</family> <given>Five</given></name>
    <email>five@foo.com</email>
    <link manager="Big.Boss"/>
  </person>

</personnel>
END

{
  $error = "";

  my $dom = new XML::Xerces::DOMParser;

  my $error_handler = new XML::Xerces::perlErrorHandler;
  $error_handler->setWarningFunction(\&warning);
  $error_handler->setErrorFunction(\&error);
  $error_handler->setFatalErrorFunction(\&fatal_error);
  $dom->setErrorHandler($error_handler);

  eval {
    $dom->parse( new XML::Xerces::MemBufInputSource($document, 'foo') );
  };

  my $expected_error = <<EOE;
FATAL ERROR:
LINE:    23
COLUMN:  11
MESSAGE: Expected end of tag 'foo'
EOE
  result($expected_error eq $error);

}

{
  $error = "";

  my $dom = new XML::Xerces::DOMParser;

  $error_handler = new XML::Xerces::perlErrorHandler;
  $error_handler->setWarningFunction(\&warning);
  $error_handler->setErrorFunction(\&error);
  $error_handler->setFatalErrorFunction(\&fatal_error);
  $dom->setErrorHandler($error_handler);

  $dom->setDoValidation(1);
  eval {
    $dom->parse( new XML::Xerces::MemBufInputSource($document, 'foo') );
  };

  my $expected_error = <<EOE;
ERROR:
LINE:    19
COLUMN:  7
MESSAGE: Unknown element 'foo'
EOE
  result($expected_error eq $error);
}

sub warning {
  $error = "WARNING:\nLINE:    " . $_[0]->getLineNumber . "\nCOLUMN:  " . $_[0]->getColumnNumber . "\nMESSAGE: " . $_[0]->getMessage . "\n";
  die "\n";
}

sub error {
  $error = "ERROR:\nLINE:    " . $_[0]->getLineNumber . "\nCOLUMN:  " . $_[0]->getColumnNumber . "\nMESSAGE: " . $_[0]->getMessage . "\n";
  die "\n";
}

sub fatal_error {
  $error = "FATAL ERROR:\nLINE:    " . $_[0]->getLineNumber . "\nCOLUMN:  " . $_[0]->getColumnNumber . "\nMESSAGE: " . $_[0]->getMessage . "\n";
  die "\n";
}
